' RoTex(texture:TTexture, angle:Float, Scale:Float = 1)
' CreateGrid:TPixmap(size:Int=512,R:Int = 255, G:Int = 255, B:Int = 255, Alpha:Int = 255)
' CreateSunTexture:TPixmap()
' CreateBaseTexture:TPixmap(size:Int=32,r:Int=255,g:Int=255,b:Int=255,a:Float=1.0)



' ------------------------------------------------------------------------------------------------
' Rotate and scale a texture using separate calculations
' ------------------------------------------------------------------------------------------------
Function RoTex(texture:TTexture, angle:Float, Scale:Float = 1)

	Local x:Float
	Local y:Float

	ScaleTexture texture, Scale, Scale
	
	RotateTexture texture, angle
	
	x = Cos(angle) / Scale / 2.0
	y = Sin(angle) / Scale / 2.0
	
	PositionTexture texture, (x - 0.5) - y, (y - 0.5) + x
	
End Function



' ------------------------------------------------------------------------------------------------
' Create a Grid Texture
' ------------------------------------------------------------------------------------------------
Function CreateGrid:TPixmap(Size:Int = 512, R:Int = 255, G:Int = 255, B:Int = 255, Alpha:Int = 255)

	Local pixmap:TPixmap = CreatePixmap(Size, Size, PF_RGBA8888)

	For Local x:Int = 0 To Size - 1
		
		For Local y:Int = 0 To Size - 1
		
			WritePixel(pixmap, x, y, CombineRGBA(R, G, B, Alpha / 50))
		
			If x = 0 Or x = Size - 1 Then WritePixel(pixmap, x, y, CombineRGBA(R, G, B, Alpha))
			If y = 0 Or y = Size - 1 Then WritePixel(pixmap, x, y, CombineRGBA(R, G, B, Alpha))
		
		Next
	
	Next
	
	Return pixmap

End Function



' ------------------------------------------------------------------------------------------------
' Creates a Sun Texture
' ------------------------------------------------------------------------------------------------
Function CreateSunTexture:TPixmap()
	
	Local pixmap:TPixmap = CreatePixmap(512, 512, PF_RGBA8888)
	
	Local i:Float, j:Int, col:Int, rgb:Int
	
	For j = 0 To 255
		
		col = 255 - j
		If col > 255 Then col = 255
		rgb = col * $1000000 + col * $10000 + col * $100 + col
		
		For i = 0 To 360 Step 0.1
			
			WritePixel(pixmap, 256 + (Sin(i) * j), 256 + (Cos(i) * j), rgb)
			
		Next
		
	Next
	
	Return pixmap
	
End Function



' ----------------------------------------------------------------------------
' create a unicolor base texture for coloring a mesh
' ----------------------------------------------------------------------------
Function CreateBaseTexture:TPixmap(Size:Int = 32, r:Int = 255, g:Int = 255, b:Int = 255, a:Float = 1.0)
	
	Local x:Int, y:Int
	Local pixmap:TPixmap = CreatePixmap(Size, Size, PF_RGBA8888)
	
	For x = 0 To Size - 1

		For y = 0 To Size - 1

			WritePixel(pixmap, x, y, CombineRGBA(r, g, b, a * 255))

		Next

	Next
	
	Return pixmap
		
End Function