Global MAXGUI_Resolutions:String[999]
Global MAXGUI_CURRENT_Width:Int
Global MAXGUI_CURRENT_Height:Int



' ------------------------------------------------------------------------------------------------
' Simplifies using max2d with a resizable canvas - by Hezkore
' ------------------------------------------------------------------------------------------------
Function MAXGUI_UpdateCanvas(can:TGadget)

	SetGraphics(CanvasGraphics(can))

	If TGlobal.width[0] <> ClientWidth(can) Or TGlobal.height[0] <> ClientHeight(can)

		BeginMax2D()
		SetGraphics(CanvasGraphics(can))
		SetViewport(0, 0, ClientWidth(can), ClientHeight(can))
		EndMax2D()
		
		TGlobal.width[0] = ClientWidth(can) ' values used in texture rendering
		TGlobal.Height[0] = ClientHeight(can)

	EndIf

EndFunction



' ------------------------------------------------------------------------------------------------
' Close the Application with a confirm Question
' ------------------------------------------------------------------------------------------------
Function MAXGUI_Appclose()

	'If Confirm("Are you sure you want to exit?") Then

		EndGraphics
		End
		
	'Endif

End Function



' ------------------------------------------------------------------------------------------------
' Custom BeginMax2D function
' ------------------------------------------------------------------------------------------------
Function MAXGUI_Begin2D()

	BeginMax2D()
	
	' hack to use drawtext in canvas
	glDisable(GL_CULL_FACE)
	glMatrixMode GL_PROJECTION
	glLoadIdentity
	glOrtho 0, GraphicsWidth(), GraphicsHeight(), 0, -1, 1

End Function



' ------------------------------------------------------------------------------------------------
' Custom EndMax2D function
' ------------------------------------------------------------------------------------------------
Function MAXGUI_End2D()

	EndMax2D()

End Function



' ------------------------------------------------------------------------------------------------
' Retrieve and filter available Graphics Resolutions
' ------------------------------------------------------------------------------------------------
Function MAXGUI_GetResolutions()

	Local w:Int
	Local h:Int
	Local d:Int
	Local z:Int

	Local m:Int
	Local i:Int
	
	Local add:Int
	Local index:Int = 0
	
	'AddGadgetItem("1280x720, w + "x" + h + " (" + d + "bit, " + z + "Hz)")

	' iterate through all graphic modes
	For m = 0 To CountGraphicsModes() - 1
	
		' get available graphic modes and store them in variables
		GetGraphicsMode(m, w, h, d, z)
		
		' assuming we're adding them
		add = True
		
		' Resolution is already known or height too small? sort them out!
		For i = 0 To index
		
			If z <> 60 Then Add = False ; Exit
		
			If MAXGUI_Resolutions[i] = (w + "x" + h) Or h < 720 Then Add = False ; Exit
		
		Next
				
		' add all other resolutions to our Pulldown menu
		If add Then
		
			' add to Gadget
			AddGadgetItem(MAXGUI_Graphics_Resolution, w + "x" + h + " (" + d + "bit, " + z + "Hz)")
			
			' if the current Resolution matches Desktop resolution: preselect it!
			If w = DesktopWidth() And h = DesktopHeight() Then
			
				SelectGadgetItem(MAXGUI_Graphics_Resolution, index)
				MAXGUI_CURRENT_Width = w
				MAXGUI_CURRENT_Height = h
				
			EndIf
			
			' store the new Resolution in Array
			MAXGUI_Resolutions[index] = w + "x" + h
			
			' counter
			index:+1
			
			'Print "Found Resolution: " + w + "x" + h
			
		EndIf
				
	Next

End Function