' ResetMouse()
' CenterMouse()
' MouseZoomValue:Float(MinZoom:Float = 0.0, MaxZoom:Float = 1.0, resolution:Float = 0.1, Steps:Float = 20)
' MouseZSpeed:Float(speed_modifier:Float = 1.0)



' ------------------------------------------------------------------------------------------------
' Reset Mouse to Screen Center
' ------------------------------------------------------------------------------------------------
Function ResetMouse()

	MoveMouse GraphicsWidth() / 2, GraphicsHeight() / 2
	
	MouseXSpeed()
	MouseYSpeed()
	MouseZSpeed()
	
End Function



' ------------------------------------------------------------------------------------------------
' Move Mouse pointer to Screen Center
' ------------------------------------------------------------------------------------------------
Function CenterMouse()

	MoveMouse SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2

End Function



' ------------------------------------------------------------------------------------------------
' Mouse Zoom Value
' ------------------------------------------------------------------------------------------------
Function MouseZoomValue:Float(MinZoom:Float = 0.0, MaxZoom:Float = 1.0, resolution:Float = 0.1, Steps:Float = 20)

	Global zoom:Float = 1.0, target:Float = 1.0
	Local EPSILON:Float, tdelta:Float

	Steps = Max(Steps, 1)
	EPSILON = resolution / Steps
	target = Max(Min(target + (MouseZSpeed(resolution)), MaxZoom), MinZoom)

	tdelta = target - zoom
	If Abs(tdelta) < EPSILON Then zoom = target Else zoom = zoom + tdelta / Steps

	Return zoom
	
End Function



' ------------------------------------------------------------------------------------------------
' MouseZSpeed
' ------------------------------------------------------------------------------------------------
Function MouseZSpeed:Float(speed_modifier:Float = 1.0)

	Global Lastz:Float, Newz:Float
	Lastz = Newz
	Newz = -MouseZ()
	Return (Newz - Lastz) * speed_modifier
	
End Function