' ------------------------------------------------------------------------------------------------
' Load MEDIA
' ------------------------------------------------------------------------------------------------
Function LoadMedia()

	TIME.Start()


	' --------------------------------------------------------------------------------------------
	' Images
	' --------------------------------------------------------------------------------------------
	MEDIA.Load("IMG", "LOADINGANIMATION", "loader.png")					' Loader Animation Pic
	MEDIA.Load("IMG", "CURSORIMAGE", "blitz.png")						' Blitz Rocket Cursor
	MEDIA.LoaderAnimation = MEDIA.GetImage("LOADINGANIMATION")				' Assign Animation


	' --------------------------------------------------------------------------------------------
	' Fonts
	' --------------------------------------------------------------------------------------------
	MEDIA.Load("FNT", "FPS", "Frapsy/Frapsy.otf", 24 * Scaler)				' FPS Font
	MEDIA.Load("FNT", "SMALL", "Acorn/Acorn Nostalgia.otf", 16 * Scaler)	' Small Font
	MEDIA.Load("FNT", "LARGE", "Steelfish/Steelfish rg.otf", 64 * Scaler)	' Large Font


	' --------------------------------------------------------------------------------------------
	' Textures
	' --------------------------------------------------------------------------------------------
	MEDIA.Load("TEX", "NOTEX", "notex.png", 1 + 8)							' No Texture dummy
	MEDIA.Load("TEX", "TEST", "test.png", 1 + 8)							' Tiles Diffusemap
	MEDIA.Load("TEX", "TEST_NRM", "test_nrm.png", 1 + 8)					' Tiles Normalmap


	' --------------------------------------------------------------------------------------------
	' Sounds
	' --------------------------------------------------------------------------------------------
	MEDIA.Load("SND", "BLIP", "blip.ogg")									' A Blip


	' --------------------------------------------------------------------------------------------
	' Shaders
	' --------------------------------------------------------------------------------------------
	MEDIA.Load("SHA", "TESTSHADER", "test")									' Bumpmap Shader


	' --------------------------------------------------------------------------------------------
	' test to demonstrate creating and destroying a texture objects, unloading saves/frees VRAM
	' --------------------------------------------------------------------------------------------
	If PROJECT_DEBUG Then

		MEDIA.Load("PIX", "TMP", "test.png")
		Local pixmap:TPixmap = ConvertPixmap(MEDIA.GetPixmap("TMP"), PF_RGBA8888)
		For Local i:Int = 0 To 100

			' copy temp Pixmap to a new TMedia Texture Object
			MEDIA.PixToTex("TEX", "TEX" + i, pixmap)

			' delete this object again
			MEDIA.Unload("TEX" + i)

		Next
		MEDIA.Unload("TMP")

	EndIf

	TIME.Stop(LOCALE.Get("LOG_MEDIALOADED"))

End Function