Type TLocale

	Global Locale:TMap = CreateMap()			' Global TMap with all text
	
	Field language:String = "EN"				' the current locale Flag
	field path:String=""						' the path to the database
	Field database:String = "locale"			' the database file name
	
	Global db:TDBConnection
	Global q:TDatabaseQuery
		
	' ------------------------------------------------------------------------------------------------
	' Resets the LOCALE TMap
	' ------------------------------------------------------------------------------------------------
	Method reset()
	
		LOCALE = Null
		LOCALE = CreateMap()
	
	End Method

	' ------------------------------------------------------------------------------------------------
	' Loads the Locale Database
	' ------------------------------------------------------------------------------------------------
	Method Load()
			
		db = LoadDatabase("SQLITE", path + database + ".db")
		
		If db Then Update()
								
	End Method

	' ------------------------------------------------------------------------------------------------
	' Updates the LOCALE TMap
	' ------------------------------------------------------------------------------------------------
	Method Update()
	
		reset()
	
		q = db.executeQuery("SELECT * from locale")
	
		While q.nextRow()

			' get record
			Local r:TQueryRecord = q.rowRecord()
			Local cat:String = r.getStringByName("category")
			Local Key:String = r.getStringByName("key")
			
			MapInsert(LOCALE, cat + "_" + Key, r.getStringByName(language))
									
		Wend
		
		LogUpdate(Get("LOG_LOCALIZATIONDATABASE") + " '" + language + "' " + Get("LOG_LOADED"))
		
		'db.close()
	
	End Method
	
	' ------------------------------------------------------------------------------------------------
	' Returns Locale Object
	' ------------------------------------------------------------------------------------------------
	Method Get:String(Key:String)
	
		Return String(MapValueForKey(LOCALE, Key))
			
	End Method

	' ------------------------------------------------------------------------------------------------
	' Returns an Array from a Locale Object
	' ------------------------------------------------------------------------------------------------
	Method CreateArray:String[] (Key:String, strPtr:String[] Var, separator:String = "|")
			
		strPtr = String(MapValueForKey(LOCALE, Key)).Split(separator)

	End Method
	
End Type